//+------------------------------------------------------------------+
//|                                                Stochastic MA.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window

extern int MA_Period=13;
extern int MA_Method=0;
extern int MA_Shift=0;
double ExtMapBuffer[];
extern int RSITF=13;
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
int    draw_begin;
   string short_name;
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexShift(0,MA_Shift);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
   if(MA_Period<2) MA_Period=13;
   draw_begin=MA_Period-1;
   switch(MA_Method)
     {
      case 1 : short_name="EMA(";  draw_begin=0; break;
      default :
         MA_Method=0;
         short_name="SMA(";
     }
//---- indicator short name
   IndicatorShortName(short_name+MA_Period+")");
   SetIndexDrawBegin(0,draw_begin);
//---- indicator buffers mapping
   SetIndexBuffer(0,ExtMapBuffer);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   if(Bars<=MA_Period) return(0);
   ExtCountedBars=IndicatorCounted();
//---- check for possible errors
   if (ExtCountedBars<0) return(-1);
//---- last counted bar will be recounted
   if (ExtCountedBars>0) ExtCountedBars--;
//----
   switch(MA_Method)
     {
      case 0 : sma();  break;
      case 1 : ema();  break;
     }
//---- done
   return(0);
  }

void sma()  
  {
   int    counted_bars=IndicatorCounted();
   double sum=0;
   int    i,pos=Bars-ExtCountedBars-1;
//---- initial accumulation
   if(pos<MA_Period) pos=MA_Period;
   for(i=1;i<MA_Period;i++,pos--)
      {
      sum+=iVolume(Symbol(),0,pos);
      }
//---- main calculation loop
   while(pos>=0)
     {
      sum+=iVolume(Symbol(),0,pos);
      ExtMapBuffer[pos]=sum/MA_Period;
	   sum-=iVolume(Symbol(),0,pos+MA_Period-1);
 	   pos--;
     }
//---- zero initial bars
   if(ExtCountedBars<1)
     {
      for(i=1;i<MA_Period;i++) ExtMapBuffer[Bars-i]=0;
     }
  }
//+------------------------------------------------------------------+

void ema()
  {
   double pr=2.0/(MA_Period+1);
   int    pos=Bars-2;
   if(ExtCountedBars>2) pos=Bars-ExtCountedBars-1;
//---- main calculation loop
   while(pos>=0)
     {
      if(pos==Bars-2) ExtMapBuffer[pos+1]=iVolume(Symbol(),0,pos+1);
      ExtMapBuffer[pos]=iVolume(Symbol(),0,pos)*pr+ExtMapBuffer[pos+1]*(1-pr);
 	   pos--;
 	  }
  }

